#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <initguid.h>
#define D3D_OVERLOADS
#include <ddraw.h>
#include <d3d.h>

// global defs
// graphics
#define XRES 512
#define YRES 384
#define BITS 16
#define VIEWDIV 8
#define MAXHEIGHT 4
#define FIELDX 256
#define FIELDY 256
#define TEXX 8 // Anz der Tex's in X-Richtung
#define TEXY 8
#define TXRES 128 // Anz der Texel in einer Textur
#define TYRES 128
#define FXRES (TXRES*TEXX/FIELDX) // Anz der Texel in X-Richtung pro Feld
#define FYRES (TYRES*TEXY/FIELDY)
#define TEXSPACEOFF 3
// game
#define OMILS 4
// math
#define PI 3.141592654

// windows
HWND hwnd;
MSG messages;
WNDCLASS wincl; 
BOOL bQuit=FALSE;
char szClassName[ ] = "WindowsApp";
// prototypes
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

// DirectX
// defs
#define DXXRESULT(a,b,c) -((a.y-b.y)*(c.z-b.z)-(a.z-b.z)*(c.y-b.y))
#define DXYRESULT(a,b,c) -((a.z-b.z)*(c.x-b.x)-(a.x-b.x)*(c.z-b.z))
#define DXZRESULT(a,b,c) -((a.x-b.x)*(c.y-b.y)-(a.y-b.y)*(c.x-b.x))
#define DXNORM(a,b,c) dxfix(DXXRESULT(a,b,c),DXYRESULT(a,b,c),DXZRESULT(a,b,c))
#define RELEASE(x) if (x) { (x)->Release(); (x)=NULL; }

// vars
LPDIRECTDRAW dxdd;
DDSURFACEDESC dxsd;
D3DVIEWPORT dxviewport;
LPDIRECTDRAWSURFACE dxprimary = NULL;
LPDIRECTDRAWSURFACE dxbackbuffer = NULL;
LPDIRECTDRAWSURFACE dxzbuffer = NULL;
LPDIRECT3D2 dxd3d = NULL;
LPDIRECT3DDEVICE2 dxd3ddevice = NULL;
LPDIRECT3DVIEWPORT2 dxd3dviewport = NULL;
DDBLTFX dxblt;
// lighting
LPDIRECT3DLIGHT dxd3dlight;
D3DLIGHT dxlight;
LPDIRECT3DMATERIAL2 dxd3dmat;
D3DMATERIAL dxmat;
D3DMATERIALHANDLE dxhmat;
// texturing
D3DTEXTUREHANDLE dxhtexture[3+TEXX*TEXY];
LPDIRECTDRAWSURFACE dxstexture;
LPDIRECT3DTEXTURE2 dxtexture;
HDC dxtexturedc;
// transforming
D3DMATRIX matrix;

// types
// dx objects
struct dxtriangle {
  long num;
  D3DVERTEX* v;
  unsigned tex;
};

struct dx3dobject {
  long lists, strips, fans;
  dxtriangle *list, *strip, *fan;
} obj;

// game
float t;// time

// terrain
struct tterrain{
  unsigned char hmap[FIELDX][FIELDY];
  D3DVECTOR norm[FIELDX][FIELDY];
}terra;

// view
struct tview {
  float px, py;// scroll
} view;

struct mil {
  float x, y, z, a, b, c;
  char owner;
  int target;
} omil[OMILS];

D3DVECTOR dxfix(float x, float y, float z){
  float len=sqrt(x*x+y*y+z*z);
  D3DVECTOR v=D3DVECTOR(x/len, y/len, z/len);
  return v;
}

void status(long s){
  FILE *f;
  f=fopen("status.txt", "w");
  fseek(f, 0, SEEK_SET);
  fwrite( &s, sizeof(s), 1, f);
  fclose(f);
}

void dxloadobject(char* fname){
  FILE *f;
  unsigned short typ;
  float scalex, scaley, scalez, fl;
  D3DVECTOR v[3];
  float tu[3], tv[3];
  obj.lists=obj.strips=obj.fans=0;
  obj.list=NULL;
  obj.strip=NULL;
  obj.fan=NULL;
  f=fopen(fname, "rb");
  fseek(f, 0, SEEK_SET);
  while(!feof(f)){
    fread(&typ, 2, 1, f);
    if(typ==0){
      fread(&scalex, 4, 1, f);
      fread(&scaley, 4, 1, f);
      fread(&scalez, 4, 1, f);
    }
    if(typ==1){
      obj.lists++;
      if(obj.list==NULL){
        obj.list=(dxtriangle*)malloc(obj.lists*sizeof(dxtriangle));
      } else {
        obj.list=(dxtriangle*)realloc(obj.list, obj.lists*sizeof(dxtriangle));
      }
      fread(&fl, 4, 1, f);obj.list[obj.lists-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj.list[obj.lists-1].tex=(unsigned)fl;
      obj.list[obj.lists-1].v=(D3DVERTEX*)malloc(obj.list[obj.lists-1].num*sizeof(D3DVERTEX));
      for(int i=0;i<obj.list[obj.lists-1].num/3;i++){
        for(int j=0;j<3;j++){
          fread(&fl, 4, 1, f);v[j].x=scalex*fl;
          fread(&fl, 4, 1, f);v[j].y=scaley*fl;
          fread(&fl, 4, 1, f);v[j].z=scalez*fl;
          fread(&tu[j], 4, 1, f);
          fread(&tv[j], 4, 1, f);
        }
        for(int j=0;j<3;j++){
          obj.list[obj.lists-1].v[i*3+j]=D3DVERTEX(v[j], DXNORM(v[0], v[1], v[2]),tu[j], tv[j]);
        }  
      }
    }
    if(typ==2){
      obj.strips++;
      if(obj.strip==NULL){
        obj.strip=(dxtriangle*)malloc(obj.strips*sizeof(dxtriangle));
      } else {
        obj.strip=(dxtriangle*)realloc(obj.strip, obj.strips*sizeof(dxtriangle));
      }
      fread(&fl, 4, 1, f);obj.strip[obj.strips-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj.strip[obj.strips-1].tex=(unsigned)fl;
      obj.strip[obj.strips-1].v=(D3DVERTEX*)malloc(obj.strip[obj.strips-1].num*sizeof(D3DVERTEX));
      // first 3
      for(int i=0;i<3;i++){
        fread(&fl, 4, 1, f);v[i].x=scalex*fl;
        fread(&fl, 4, 1, f);v[i].y=scaley*fl;
        fread(&fl, 4, 1, f);v[i].z=scalez*fl;
        fread(&tu[i], 4, 1, f);
        fread(&tv[i], 4, 1, f);
      }
      for(int i=0;i<3;i++){
        obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[i], DXNORM(v[0], v[1], v[2]),tu[i], tv[i]);
      }  
      if(obj.strip[obj.strips-1].num>3){
        for(int i=3;i<obj.strip[obj.strips-1].num;i++){
          fread(&fl, 4, 1, f);v[(i-3)%3].x=scalex*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].y=scaley*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].z=scalez*fl;
          fread(&tu[(i-3)%3], 4, 1, f);
          fread(&tv[(i-3)%3], 4, 1, f);
          if(i%2==0){
            obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[0], v[1], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          } else {
            obj.strip[obj.strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[1], v[0], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          }
        }
      }
    }
  }
  fclose(f);
}

void dxcleanup(void){
  if (dxd3ddevice && dxd3dviewport){
    dxd3ddevice->DeleteViewport(dxd3dviewport);
  }
  RELEASE(dxd3dviewport);
  RELEASE(dxd3ddevice);
  RELEASE(dxd3d);
  RELEASE(dxprimary);
  RELEASE(dxdd);
}

void dxerror(void){
  dxcleanup();
  DestroyWindow(hwnd);
  exit(0);
}

void winerror(void){
  DestroyWindow(hwnd);
  exit(0);
}

void initterratex(void){
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = TXRES;
  dxsd.dwHeight = TYRES;
  for(int i=0;i<TEXX;i++){
    for(int j=0;j<TEXY;j++){
      dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
      if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
        dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
        if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK) dxerror();
      }
      dxstexture->GetDC(&dxtexturedc);
      for(int k=0;k<TXRES;k++){
        for(int l=0;l<TYRES;l++){
          SetPixel(dxtexturedc, k, l, (256)*(128+rand()%128));
        }
      }    
      dxstexture->ReleaseDC(dxtexturedc);
      if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
      dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[TEXSPACEOFF+j*TEXX+i]);
      dxtexture->Release();
    }
  }
}

void dxinittex(void){
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  // tex.tarnfleck
  dxsd.dwWidth = 64;
  dxsd.dwHeight = 64;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture, NULL);  
  }
  dxstexture->GetDC(&dxtexturedc);
  for(int i=0;i<64;i++){
    for(int j=0;j<64;j++){
      SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*(sin(i/8.0)*sin(j/5.0)*0.25+0.75)*(sin(j/8.0)*cos(i/15.0)*0.25+0.75)));
    }
  }    
  dxstexture->ReleaseDC(dxtexturedc);
  if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[0]);
  dxtexture->Release();
  // tex.ketten
  dxsd.dwWidth = 32;
  dxsd.dwHeight = 32;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
  if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
    dxdd->CreateSurface(&dxsd, &dxstexture, NULL);  
  }
  dxstexture->GetDC(&dxtexturedc);
  for(int i=0;i<32;i++){
    for(int j=0;j<32;j++){
      if(i>6&&i<32-6){
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*((j/4)%2)));
      } else {
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*(((j/4)+1)%2)));
      }
    }
  }    
  dxstexture->ReleaseDC(dxtexturedc);
  if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[1]);
  dxtexture->Release();
  // tex.hgras
  dxsd.dwWidth = 8;
  dxsd.dwHeight = 8;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture, NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture, NULL);  
  }
  dxstexture->GetDC(&dxtexturedc);
  for(int i=0;i<8;i++){
    for(int j=0;j<8;j++){
      SetPixel(dxtexturedc, i, j, (256)*(128+rand()%128));
    }
  }    
  dxstexture->ReleaseDC(dxtexturedc);
  if(dxstexture->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[2]);
  dxtexture->Release();
  initterratex();
}

void dxinitlight(){
  // material
  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  memset(&dxmat, 0, sizeof(D3DMATERIAL));
  dxmat.dwSize = sizeof(D3DMATERIAL);
  dxmat.diffuse.r = 1.0;
  dxmat.diffuse.g = (D3DVALUE)1.0;
  dxmat.diffuse.b = (D3DVALUE)1.0;
  dxmat.ambient.r = 1.0;
  dxmat.ambient.g = (D3DVALUE)1.0;
  dxmat.ambient.b = (D3DVALUE)1.0;
  dxmat.specular.r = (D3DVALUE)0.3;// Licht spiegeln
  dxmat.specular.g = (D3DVALUE)0.3;
  dxmat.specular.b = (D3DVALUE)0.3;
  dxmat.dwRampSize = 0;
  // mat.background
  dxd3dmat->SetMaterial(&dxmat);
  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
  dxd3dviewport->SetBackground(dxhmat);
  // mat.objects
  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  dxmat.power = (float)0.5;
  dxmat.dwRampSize = 16;
  dxd3dmat->SetMaterial(&dxmat);
  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
  // lighting
  dxd3d->CreateLight(&dxd3dlight, NULL);
  memset(&dxlight, 0, sizeof(D3DLIGHT));
  dxlight.dwSize = sizeof(D3DLIGHT);
  dxlight.dltType = D3DLIGHT_DIRECTIONAL;
  dxlight.dcvColor.r = 0;
  dxlight.dcvColor.g = 0.0;
  dxlight.dcvColor.b = D3DVAL(0.8);
  dxlight.dvAttenuation0 = 0.0;
  dxlight.dvAttenuation1 = 0.0;
  dxlight.dvAttenuation2 = 0.0;
  dxlight.dvPosition.x = 0.0;
  dxlight.dvPosition.y = D3DVAL(0.0);
  dxlight.dvPosition.z = D3DVAL(0);
  dxlight.dvDirection.x = -1;
  dxlight.dvDirection.y = D3DVAL(0.0);
  dxlight.dvDirection.z = D3DVAL(1);
  dxd3dlight->SetLight(&dxlight);
  dxd3dviewport->AddLight(dxd3dlight);
  dxd3d->CreateLight(&dxd3dlight, NULL);
  dxlight.dcvColor.r = 0.8;
  dxlight.dcvColor.g = 0.7;
  dxlight.dcvColor.b = D3DVAL(0.2);
  dxlight.dvDirection.x = 1;
  dxlight.dvDirection.y = D3DVAL(0.0);
  dxlight.dvDirection.z = D3DVAL(0.5);
  dxd3dlight->SetLight(&dxlight);
  dxd3dviewport->AddLight(dxd3dlight);
}

void dxinit(void){
  // Init DirectX and Direct3D
  // create direct draw object on primary surface
  if (DirectDrawCreate(NULL, &dxdd, NULL )!=DD_OK) dxerror();
  // set the cooperative level
  if (dxdd->SetCooperativeLevel(hwnd, DDSCL_FULLSCREEN  | DDSCL_EXCLUSIVE | DDSCL_ALLOWMODEX | DDSCL_FPUSETUP)!=DD_OK) dxerror();
  dxdd->SetDisplayMode(XRES,YRES,BITS);
  // create the primary surface
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS;
  dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK) dxerror();
  }
  // Create backbuffer
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK) dxerror();
  }
  if (dxprimary->AddAttachedSurface(dxbackbuffer) != DD_OK) dxerror();
  // Create a z-buffer and attach it to the backbuffer
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_ZBUFFERBITDEPTH;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.dwZBufferBitDepth = 16;
  dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
  if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK) dxerror();
  }  
  if (dxbackbuffer->AddAttachedSurface(dxzbuffer) != DD_OK) dxerror();
  // get the direct3d object
  if (dxdd->QueryInterface(IID_IDirect3D2, (LPVOID*)&dxd3d)!=DD_OK) dxerror();
  // create the direct 3d device from the surface
//  if (dxd3d->CreateDevice(IID_IDirect3DTnLHALDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
    if (dxd3d->CreateDevice(IID_IDirect3DHALDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
      if (dxd3d->CreateDevice(IID_IDirect3DMMXDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
        if (dxd3d->CreateDevice(IID_IDirect3DRGBDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
          if (dxd3d->CreateDevice(IID_IDirect3DRampDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
            if (dxd3d->CreateDevice(IID_IDirect3DRefDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
              dxerror();
            }
          }
        }
      }  
    }  
//  }
  // get the surface description so we know the width & height
  if (dxprimary->GetSurfaceDesc(&dxsd)!=DD_OK) dxerror();
  // create the viewport
  if (dxd3d->CreateViewport(&dxd3dviewport, NULL)!=D3D_OK) dxerror();
  ZeroMemory(&dxviewport, sizeof(dxviewport));
  dxviewport.dwSize = sizeof(dxviewport);
  dxviewport.dwX = 0;
  dxviewport.dwY = 0;
  dxviewport.dwWidth = dxsd.dwWidth;
  dxviewport.dwHeight = dxsd.dwHeight;
  dxviewport.dvScaleX = dxsd.dwWidth/2;
  dxviewport.dvScaleY = dxsd.dwHeight/2;
  dxviewport.dvMinZ = 0.0f;
  dxviewport.dvMaxZ = 1.0f;
  dxviewport.dvMaxX = 1.0f;
  dxviewport.dvMaxY = 1.0f;
  if (dxd3ddevice->AddViewport(dxd3dviewport)!=DD_OK) dxerror();
  if (dxd3dviewport->SetViewport(&dxviewport)!=DD_OK) dxerror();
  if (dxd3ddevice->SetCurrentViewport(dxd3dviewport)!=DD_OK) dxerror();
  // lighting
  dxinitlight();
  // textures
  dxinittex();
  // state
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE,TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREMAG, D3DFILTER_MIPLINEAR);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREMIN, D3DFILTER_MIPLINEAR);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZENABLE,TRUE);//D3DZB_USEW
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,TRUE);
  dxd3ddevice->SetLightState(D3DLIGHTSTATE_MATERIAL,dxhmat);
  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(80, 80, 80, 80));
//  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(255, 255, 255, 255));
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_LIGHTING,TRUE); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_EDGEANTIALIAS,TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_FILLMODE, D3DFILL_WIREFRAME);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0.5, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,0.5,0, 0,0,0.8,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  // load objects
  dxloadobject("tank.3do");
}

void renderobj(dx3dobject obj, float x, float y, float z, float a, float b, float c){
//  D3DVERTEX v[3];
  // transformations
  matrix=D3DMATRIX(cos(a),sin(a),0,0, -sin(a),cos(a),0,0, 0,0,1,0, x, y, z, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(b),-sin(b),0, 0,sin(b),cos(b),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(c),0,-sin(c),0, 0,1,0,0, sin(c),0,cos(c),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  // drawing
  if(obj.lists>0){
    for(int i=0;i<obj.lists;i++){
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.list[i].tex]);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLELIST,D3DVT_VERTEX,&obj.list[i].v[0],obj.list[i].num,D3DDP_WAIT);
    }
  }
  if(obj.strips>0){
    for(int i=0;i<obj.strips;i++){
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.strip[i].tex]);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DVT_VERTEX,&obj.strip[i].v[0],obj.strip[i].num,D3DDP_WAIT);
    }
  }
}

int begr(int x, int ber){
  while(x<0)x+=ber;
  while(x>=ber)x-=ber;
  return x;
}

float begrf(float x, float ber){
  while(x<0)x+=ber;
  while(x>=ber)x-=ber;
  return x;
}

void renderterra(void){
  D3DVERTEX vx[4];
  int l=-15, r=16, o=22, u=-32;
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  for(int j=u+(int)view.py;j<o+(int)view.py;j++){
    for(int i=l+(int)view.px;i<r+(int)view.px;i++){
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[TEXSPACEOFF+(begr(j, FIELDY)*TEXY/FIELDY)*TEXX+begr(i, FIELDX)*TEXX/FIELDX]);
      vx[0]=D3DVERTEX(D3DVECTOR(i, j, -terra.hmap[begr(i,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT), terra.norm[begr(i, FIELDX)][begr(j, FIELDX)], FXRES*1.0f/TXRES*i, FYRES*1.0f/TYRES*j);
      vx[1]=D3DVERTEX(D3DVECTOR(i, j+1, -terra.hmap[begr(i,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT), terra.norm[begr(i, FIELDX)][begr(j+1, FIELDX)], FXRES*1.0f/TXRES*i+FXRES*1.0f/TXRES, FYRES*1.0f/TYRES*j);
      vx[2]=D3DVERTEX(D3DVECTOR(i+1, j, -terra.hmap[begr(i+1,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT), terra.norm[begr(i+1, FIELDX)][begr(j, FIELDX)], FXRES*1.0f/TXRES*i, FYRES*1.0f/TYRES*j+FYRES*1.0f/TYRES);
      vx[3]=D3DVERTEX(D3DVECTOR(i+1, j+1, -terra.hmap[begr(i+1,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT), terra.norm[begr(i+1, FIELDX)][begr(j+1, FIELDX)], FXRES*1.0f/TXRES*i+FXRES*1.0f/TXRES, FYRES*1.0f/TYRES*j+FYRES*1.0f/TYRES);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DVT_VERTEX,&vx[0],4,D3DDP_WAIT);
    }
  }  
}

void rendermil(mil milobj){
  renderobj(obj, milobj.x, milobj.y, milobj.z, milobj.a, milobj.b, milobj.c);
}

void render(void){
  // claer zbuf, backbuf
  ZeroMemory(&dxblt, sizeof(dxblt));
  dxblt.dwSize = sizeof(dxblt);
  if(dxbackbuffer->Blt(NULL,NULL,NULL,DDBLT_WAIT|DDBLT_COLORFILL,&dxblt)!=DD_OK) dxerror();
  D3DRECT rect;
  rect.x1 = 0;rect.y1 = 0;
  rect.x2 = XRES; rect.y2 = YRES;
  if(dxd3dviewport->Clear(1, &rect, D3DCLEAR_ZBUFFER)!=DD_OK) dxerror();
  // set up camera
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, -view.px,-view.py,0,VIEWDIV);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(PI/4),sin(PI/4),0, 0,-sin(PI/4),cos(PI/4),0, 0,0,0,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
//  view.px+=0.1;
  // draw scene
  if (dxd3ddevice->BeginScene()!=D3D_OK) dxerror();
  renderterra();
  for(int i=0;i<OMILS;i++){
    rendermil(omil[i]);
  };
  if (dxd3ddevice->EndScene()!=D3D_OK) dxerror();
  // flip buffers
  dxprimary->Flip(NULL,DDFLIP_WAIT);//DDFLIP_NOVSYNC
}

BOOL wininit(HINSTANCE hThisInstance){
  wincl.hInstance = hThisInstance;
  wincl.lpszClassName = szClassName;
  wincl.lpfnWndProc = WindowProcedure;    
  wincl.style = CS_NOCLOSE;               
  wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
  wincl.lpszMenuName = NULL;
  wincl.cbClsExtra = 0;                   
  wincl.cbWndExtra = 0;                   
  wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  if(!RegisterClass(&wincl)) return FALSE;
  hwnd = CreateWindowEx(
           WS_EX_TOPMOST,
           szClassName,
           "Tank 3.0",         
           WS_POPUPWINDOW,
           0,
           0,
           XRES,
           YRES, 
           HWND_DESKTOP,  
           NULL,            
           hThisInstance,    
           NULL           
           );
  ShowWindow(hwnd, SW_SHOWMAXIMIZED);
  return true;
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message){
           case WM_DESTROY:
             PostQuitMessage(0);
           break;
           case WM_KEYDOWN:
             if(wParam==VK_ESCAPE)PostQuitMessage(0);
           break;
           default:
           return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

void terranorm(void){
  D3DVECTOR v[3];
  for(int j=0;j<FIELDY;j++){
    for(int i=0;i<FIELDX;i++){
      v[0]=D3DVECTOR(i, j, -terra.hmap[begr(i,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT);
      v[1]=D3DVECTOR(i, j+1, -terra.hmap[begr(i,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT);
      v[2]=D3DVECTOR(i+1, j, -terra.hmap[begr(i+1,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT);
      terra.norm[i][j]=DXNORM(v[0], v[1], v[2]);
    }
  }
}

void terrainit(void){
  float thmap[FIELDX][FIELDY];
  float min, max;
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      thmap[i][j]=begr(rand(), 10000);
    }
  }
  int anz=2;
  for(int k=0;k<anz;k++){
    for(int i=0;i<FIELDX;i++){
      for(int j=0;j<FIELDY;j++){
        thmap[i][j]=(thmap[i][j]+thmap[begr(i+1,FIELDX)][j]+thmap[i][begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)][begr(j+1,FIELDY)]
                    +thmap[begr(i-1,FIELDX)][j]+thmap[i][begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)][begr(j-1,FIELDY)])/7;
      }
    }  
  }
  min=thmap[0][0];
  max=thmap[0][0];
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      if(thmap[i][j]>max)max=thmap[i][j];
      if(thmap[i][j]<min)min=thmap[i][j];
    }
  }  
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      terra.hmap[i][j]=(unsigned char)(((thmap[i][j]-min)/(max-min))*255.0);
    }
  }
  terranorm();
}

void input(void){
  if(GetAsyncKeyState(0x26)!=0){omil[0].x-=sin(omil[0].a)*0.15;omil[0].y+=cos(omil[0].a)*0.15;}
  if(GetAsyncKeyState(0x28)!=0){omil[0].x+=sin(omil[0].a)*0.1;omil[0].y-=cos(omil[0].a)*0.1;}
  if(GetAsyncKeyState(0x25)!=0){omil[0].a+=0.1;}
  if(GetAsyncKeyState(0x27)!=0){omil[0].a-=0.1;}
/*  if((GetAsyncKeyState(0x27)&128==128||GetAsyncKeyState(0x27)&1==1)){shoot(0);}
  if((GetAsyncKeyState(0x0D)&128==128||GetAsyncKeyState(0x0D)&1==1)){shoot(0);}*/
}

float minf(float a, float b){
  if(a<b){
    return a;
  }else{
    return b;
  }
}

float height(float x, float y){
  int xi, yi;
  xi=x<0?((int)x-1):(int)x;
  yi=y<0?((int)y-1):(int)y;
  return -(terra.hmap[begr(xi, FIELDX)][begr(yi, FIELDY)]*(1-(x-xi))*(1-(y-yi))
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi, FIELDY)]*(x-xi)*(1-(y-yi))
          +terra.hmap[begr(xi, FIELDX)][begr(yi+1, FIELDY)]*(1-(x-xi))*(y-yi)
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi+1, FIELDY)]*(x-xi)*(y-yi)
          )/255.0*MAXHEIGHT;
}

void ki(int n){
  if(omil[n].target==-1){
    for(int i=0;i<OMILS;i++){
      if(i!=n&&omil[i].owner!=omil[n].owner){
        omil[n].target=i;
      }
    }
  }
  if(omil[n].target!=-1){
    if(omil[omil[n].target].y-omil[n].y!=0){
      float atot=atan((omil[n].x-omil[omil[n].target].x)/(omil[omil[n].target].y-omil[n].y));
      if(omil[omil[n].target].y<omil[n].y)atot=atot+PI;
      float posd=100, negd=100;
      if(atot-omil[n].a>0&&atot-omil[n].a<posd)posd=atot-omil[n].a;
      if(omil[n].a-atot>0&&omil[n].a-atot<negd)negd=omil[n].a-atot;
      if(atot-omil[n].a+2*PI>0&&atot-omil[n].a+2*PI<posd)posd=atot-omil[n].a+2*PI;
      if(omil[n].a-atot+2*PI>0&&omil[n].a-atot+2*PI<negd)negd=omil[n].a-atot+2*PI;
      if(atot-omil[n].a-2*PI>0&&atot-omil[n].a-2*PI<posd)posd=atot-omil[n].a-2*PI;
      if(omil[n].a-atot-2*PI>0&&omil[n].a-atot-2*PI<negd)negd=omil[n].a-atot-2*PI;
      if(posd<negd){
        omil[n].a+=minf(0.05, posd*0.5);
      }else{
        omil[n].a-=minf(0.05, negd*0.5);
      }
    }
  }
}

void calculate(void){
  for(int i=0;i<OMILS;i++){
    omil[i].z=height(omil[i].x, omil[i].y)-0.35;
    omil[i].b=0.5*(height(omil[i].x+sin(omil[i].a), omil[i].y-cos(omil[i].a))-height(omil[i].x-sin(omil[i].a), omil[i].y+cos(omil[i].a)));
    omil[i].c=0.5*(height(omil[i].x-cos(omil[i].a), omil[i].y-sin(omil[i].a))-height(omil[i].x+cos(omil[i].a), omil[i].y+sin(omil[i].a)));
    omil[i].a=begrf(omil[i].a, 2*PI);
    if(omil[i].owner!=0){
      ki(i);
    }
  }
}

void gameinit(void){
  for(int i=0;i<OMILS;i++){
    omil[i].owner=i==0?0:1;
    omil[i].target=-1;
  }
}

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil){
  if(!wininit(hThisInstance))winerror();
  dxinit();
  terrainit();
  gameinit();
  // render
  while ( !bQuit ) {
    if ( PeekMessage( &messages, NULL, 0, 0, PM_REMOVE ) ) {
      if ( messages.message == WM_QUIT ) {
        bQuit=TRUE;
      } else {
        TranslateMessage( &messages );
        DispatchMessage( &messages );
      }
    } else {
      input();
      calculate();
      render();
      t+=0.005;
    }
  }  
  dxcleanup();
  DestroyWindow(hwnd);
  return 0;
}

